'This Program is for loading XML file into UltraTree Control
'Prathap

#Region "NameSpaces"
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinTree
Imports System.Xml
Imports System.Xml.Schema
Imports System.IO
Imports System.Text
Imports System.Security.Cryptography
Imports Microsoft.Win32
Imports System.Configuration
Imports System.Data
#End Region

Public Class TDUltraTree

#Region "Time Band Structure"
    ''' <summary>
    ''' structure fpr Time band elements
    ''' creating the constructor for TariffData TimeBandComponent for capturing values
    ''' </summary>
    ''' <remarks></remarks>
    Public Structure struct_TariffData_TimeBandComponent
        Public Name As String
        Public Type As String
        Public SpecialDate As String
        Public StartTime As String
        Public EndTime As String
        Public StartDay As String
        Public EndDay As String
        Public Desc As String

        'Constructor
        Public Sub New(ByVal strName As String, ByVal strType As String, ByVal strSpecialDate As String, ByVal strStartTime As String, ByVal strEndTime As String, ByVal strStartDay As String, ByVal strEndDay As String, ByVal strDesc As String)
            Name = strName
            Type = strType
            SpecialDate = strSpecialDate
            StartTime = strStartTime
            EndTime = strEndTime
            StartDay = strStartDay
            EndDay = strEndDay
            Desc = strDesc
        End Sub

    End Structure
#End Region

#Region "Member Variables"

    Public Const gstrXML_TariffData_TimeBandList As String = "TimeBandList"
    Public Const gstrXML_TariffData_TimeBand As String = "TimeBand"
    Public Const gstrXML_TariffData_TimeBandName As String = "Name"
    Public Const gstrXML_TariffData_TimeBandType As String = "Type"
    Public Const gstrXML_TariffData_TimeBandSpecialDate As String = "SpecialDate"
    Public Const gstrXML_TariffData_TimeBandStartTime As String = "StartTime"
    Public Const gstrXML_TariffData_TimeBandEndTime As String = "EndTime"
    Public Const gstrXML_TariffData_TimeBandStartDay As String = "StartDay"
    Public Const gstrXML_TariffData_TimeBandEndDay As String = "EndDay"
    Public Const gstrXML_TariffData_TimeBandDesc As String = "Desc"


    'Integer variables for storing the node count
    Private mint_TariffData_NodeCountTariffData As Integer
    Private mint_TariffData_NodeCountTimeBandList As Integer
    Private mint_TariffData_NodeCountTimeBand As Integer

    'structure for storing the node properties
    Public mstruct_TariffData_TimeBandComponent() As struct_TariffData_TimeBandComponent
    Public mstruct_TariffData_TimeBandNameComponent() As String
    Public mstruct_TariffData_TimeBandNameList() As String
#End Region

#Region "Form Load Event"
    'Form Load Event
    Private Sub TDUltraTree_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Showing the form
        Me.Show()
        'Calling function to load XML file
        'Parameter is path of XML file
        Open_TariffData_XMLToGUI("E:\RD\UltraTreeControl\UltraTreeControl\bin\\TariffData.xml")
    End Sub
#End Region

#Region "Open XML File"

    Private Function Open_TariffData_XMLToGUI(ByVal str_TariffData_FileName As String) As Boolean
        'DateTime varibales to calculate elapsed time.
        Static start_time As DateTime
        Static stop_time As DateTime
        Dim elapsed_time As TimeSpan
        start_time = Now

        Dim obj_TariffData_XmlDocument As New XmlDocument
        Dim obj_TariffData_XmlNodeTariffData As XmlNode
        Dim obj_TariffData_XmlNodeTariffData_SubNode As XmlNode
        Dim obj_TariffData_XmlNodeTimeBand As XmlNode
        Dim int_TariffData_NodeCountTariffData As Integer
        Dim int_TariffData_NodeCountTimeBand As Integer
        Dim obj_TariffData_TariffDataNode As UltraTreeNode = UTTariffData.ActiveNode
        Dim obj_TariffData_TimeBandListNode As Infragistics.Win.UltraWinTree.UltraTreeNode
        Dim obj_TariffData_TimeBandNewNode As Infragistics.Win.UltraWinTree.UltraTreeNode

        Dim int_TariffData_LoopTariffData As Integer
        Dim int_TariffData_LoopTimeBand As Integer

        Try

            ReDim mstruct_TariffData_TimeBandComponent(0)

            UTTariffData.BeginUpdate()

            'Load XML file into DOM object
            obj_TariffData_XmlDocument.Load(str_TariffData_FileName)
            'Selct a list of nodes in TariffData
            obj_TariffData_XmlNodeTariffData = obj_TariffData_XmlDocument.SelectSingleNode("TariffData")
            obj_TariffData_XmlDocument = Nothing
            'Start of TariffData
            If Not obj_TariffData_XmlNodeTariffData Is Nothing Then
                'Count number of child nodes for Tariff Data
                int_TariffData_NodeCountTariffData = obj_TariffData_XmlNodeTariffData.ChildNodes.Count
                'For loop to get nodes one by one from XML file.
                For int_TariffData_LoopTariffData = 0 To int_TariffData_NodeCountTariffData - 1
                    'Getting child nodes of each node.
                    obj_TariffData_XmlNodeTariffData_SubNode = obj_TariffData_XmlNodeTariffData.ChildNodes(int_TariffData_LoopTariffData)
                    'Checking sub node name which is matching ultra tree node name
                    If obj_TariffData_XmlNodeTariffData_SubNode.Name = "TimeBandList" Then
                        'Count Time Band Nodes
                        int_TariffData_NodeCountTimeBand = obj_TariffData_XmlNodeTariffData_SubNode.ChildNodes.Count
                        'For loop to get all time band nodes to display
                        MessageBox.Show("Number of Time Bands: " + int_TariffData_NodeCountTimeBand.ToString())
                        For int_TariffData_LoopTimeBand = 0 To int_TariffData_NodeCountTimeBand - 1
                            obj_TariffData_TimeBandListNode = Me.UTTariffData.Nodes(0).Nodes(0)
                            'Create new object for ultra tree to add new node to parent node
                            obj_TariffData_TimeBandNewNode = New Infragistics.Win.UltraWinTree.UltraTreeNode
                            'Assigning tag value
                            obj_TariffData_TimeBandNewNode.Tag = "TimeBand"
                            'assigning text value
                            obj_TariffData_TimeBandNewNode.Text = "TimeBand"
                           
                            'Get all properties of time band
                            obj_TariffData_XmlNodeTimeBand = obj_TariffData_XmlNodeTariffData_SubNode.ChildNodes(int_TariffData_LoopTimeBand)

                            'Start of TimeBandList to assign into structures(local memory for later point of use)
                            If Not obj_TariffData_XmlNodeTimeBand Is Nothing Then
                                'Assigning XML element properties(values) into array of structure for later point of use.
                                mint_TariffData_NodeCountTimeBand = mint_TariffData_NodeCountTimeBand + 1
                                ReDim Preserve mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand)
                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).Name = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandName).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")

                                If Not obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandType) Is Nothing Then
                                    mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).Type = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandType).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                End If
                                If Not obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandSpecialDate) Is Nothing Then
                                    mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).SpecialDate = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandSpecialDate).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                End If

                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).StartTime = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandStartTime).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).EndTime = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandEndTime).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).StartDay = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandStartDay).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).EndDay = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandEndDay).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                                mstruct_TariffData_TimeBandComponent(mint_TariffData_NodeCountTimeBand).Desc = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandDesc).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")

                                obj_TariffData_TimeBandNewNode.Text = obj_TariffData_XmlNodeTimeBand.SelectSingleNode(gstrXML_TariffData_TimeBandName).InnerText.ToString.Replace("&lt;", "<").Replace("&gt;", ">").Replace("&amp;", "&")
                            End If

                            'Adding node to its parent node.
                            obj_TariffData_TimeBandListNode.Nodes.Add(obj_TariffData_TimeBandNewNode)
                            'End of TimeBandList
                        Next
                    End If
                Next
            End If
            UTTariffData.EndUpdate()
            Me.UTTariffData.BringToFront()
            Me.UTTariffData.Show()
            'End of TariffData
            stop_time = Now
            elapsed_time = stop_time.Subtract(start_time)
            MessageBox.Show("Elapsed time to load XML file: " + elapsed_time.Minutes.ToString())
            UTTariffData.ExpandAll(ExpandAllType.Always)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Open TariffData XML To GUI", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Function

#End Region

End Class
